<?php
// Call HTML_Template_PHPLIBTest::main() if this source file is executed directly.
if (!defined("PHPUnit_MAIN_METHOD")) {
    define("PHPUnit_MAIN_METHOD", "HTML_Template_PHPLIBTest::main");
}

require_once "PHPUnit/Framework/TestCase.php";
require_once "PHPUnit/Framework/TestSuite.php";

require_once "HTML/Template/PHPLIB.php";

/**
 * Test class for HTML_Template_PHPLIB.
 * Generated by PHPUnit2_Util_Skeleton on 2006-11-01 at 09:51:10.
 */
class HTML_Template_PHPLIBTest extends PHPUnit_Framework_TestCase {
    /**
     * Runs the test methods of this class.
     *
     * @access public
     * @static
     */
    public static function main() {
        require_once "PHPUnit/TextUI/TestRunner.php";

        $suite  = new PHPUnit_Framework_TestSuite("HTML_Template_PHPLIBTest");
        $result = PHPUnit_TextUI_TestRunner::run($suite);
    }

    /**
     * Sets up the fixture, for example, open a network connection.
     * This method is called before a test is executed.
     *
     * @access protected
     */
    protected function setUp() {
        $this->tpl = new HTML_Template_PHPLIB(dirname(__FILE__));
        $this->tpl->setFile('testfile', 'file.tpl');
    }

    /**
     * Tears down the fixture, for example, close a network connection.
     * This method is called after a test is executed.
     *
     * @access protected
     */
    protected function tearDown() {
    }
/*
    public function testTemplate_PHPLIB() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function testSetRoot() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }
*/
    public function testSetUnknowns() {
        //keep
        $tpl = new HTML_Template_PHPLIB(dirname(__FILE__));
        $tpl->setFile('testfile', 'file.tpl');
        $tpl->setUnknowns('keep');
        $str = $tpl->finish($tpl->parse('RESULT', 'testfile'));
        $this->assertNotEquals(false, strpos($str, '{VAR1}'));
        $this->assertNotEquals(false, strpos($str, '{VAR_2}'));
        $this->assertNotEquals(false, strpos($str, '{VAR_3}'));

        //remove
        $tpl = new HTML_Template_PHPLIB(dirname(__FILE__));
        $tpl->setFile('testfile', 'file.tpl');
        $tpl->setUnknowns('remove');
        $str = $tpl->finish($tpl->parse('RESULT', 'testfile'));
        $this->assertFalse(strpos($str, '{VAR1}'));
        $this->assertFalse(strpos($str, '{VAR_2}'));
        $this->assertFalse(strpos($str, '{VAR_3}'));

        //comment
        $tpl = new HTML_Template_PHPLIB(dirname(__FILE__));
        $tpl->setFile('testfile', 'file.tpl');
        $tpl->setUnknowns('comment');
        $str = $tpl->finish($tpl->parse('RESULT', 'testfile'));
        $this->assertFalse(strpos($str, '{VAR1}'));
        $this->assertNotEquals(false, strpos($str, 'VAR1'));
        $this->assertFalse(strpos($str, '{VAR_2}'));
        $this->assertNotEquals(false, strpos($str, 'VAR_2'));
        $this->assertFalse(strpos($str, '{VAR_3}'));
        $this->assertNotEquals(false, strpos($str, 'VAR_3'));
    }

    public function testSetFile() {
        $tpl = new HTML_Template_PHPLIB(dirname(__FILE__));
        $tpl->setFile('testfile', 'file.tpl');
        //existing file
        $str = $tpl->finish($tpl->parse('RESULT', 'testfile'));
        $this->assertTrue(is_string($str));
        $this->assertNotEquals('', $str);
        //empty/non-existent file
        $this->assertEquals('', $tpl->finish($tpl->parse('RESULT', 'testfile2')));
    }

    public function testSetBlock() {
        //set block, but do not parse
        $tpl = &$this->tpl;
        $tpl->setBlock('testfile', 'someblock', 'someblock_replacement');

        $str = $tpl->finish($tpl->parse('RESULT', 'testfile'));
        $this->assertFalse(strpos($str, 'var3'));

        //parse block
        $this->setUp();
        $tpl = &$this->tpl;
        $tpl->setBlock('testfile', 'someblock', 'someblock_replacement');

        $tpl->parse('someblock_replacement', 'someblock');
        $str = $tpl->finish($tpl->parse('RESULT', 'testfile'));
        $this->assertNotEquals(false, strpos($str, 'var3'));
    }

    public function testSetVar() {
        $tpl = &$this->tpl;
        $tpl->setUnknowns('keep');
        $tpl->setVar('VAR1', 'foo');
        $tpl->setVar('VAR_3', 'bar');

        $str = $tpl->finish($tpl->parse('RESULT', 'testfile'));
        $this->assertFalse(strpos($str, '{VAR1}'));

        $this->assertNotEquals(false, strpos($str, '{VAR_2}'));
        $this->assertNotEquals(false, strpos($str, 'foo'));

        $this->assertFalse(strpos($str, '{VAR_3}'));
        $this->assertNotEquals(false, strpos($str, 'bar'));
    }
/*
    public function testSubst() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function testPSubst() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function testParse() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function testPParse() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function testGetVars() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function testGetVar() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function testGetUndefined() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function testFinish() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function testP() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function testGet() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function test_filename() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function test_varname() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function test_loadFile() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function testHalt() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }

    public function testHaltMsg() {
        // Remove the following line when you implement this test.
        throw new PHPUnit2_Framework_IncompleteTestError;
    }
*/
}

// Call HTML_Template_PHPLIBTest::main() if this source file is executed directly.
if (PHPUnit_MAIN_METHOD == "HTML_Template_PHPLIBTest::main") {
    HTML_Template_PHPLIBTest::main();
}
?>